/* GCC */
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>
#include <sstream>

#define X first
#define Y second
#define mp(a, b) make_pair((a), (b))

using namespace std;

int n, m, i, j, k, l, g, curp, curq;
vector < vector <int> > p, q;

int gcd(int a, int b)
{
    a = abs(a);
    b = abs(b);

    while(b > 0)
    {
        a = a % b;
        swap(a, b);
    }

    return a;
}

void print(int i, int j)
{
    printf("%d", p[i][j]);
    if(q[i][j] != 1)
        printf("/%d", q[i][j]);
}

int main()
{
    freopen("linear.in", "r", stdin);
    freopen("linear.out", "w", stdout);

    scanf("%d %d", &n, &m);
    p.resize(n, vector <int> (m + 1));
    q.resize(n, vector <int> (m + 1));
    for(i = 0; i < n; i++)
        for(j = 0; j <= m; j++)
        {
            scanf("%d", &p[i][j]);
            q[i][j] = 1;
        }

    for(i = 0; i < n; i++)
    {
        g = abs(p[i][0]);
        for(j = 1; j < m; j++)
            g = gcd(g, p[i][j]);

        if(g == 0)
        {
            if(p[i][m] != 0)
            {
                printf("No solution\n");
                return 0;
            }

            for(j = 0; j <= m; j++)
                p[i][j] = p[n - 1][j];
            n--;
            i--;
        }
        else
        {
            g = gcd(g, p[i][m]);
            if(g > 0)
                for(j = 0; j <= m; j++)
                    p[i][j] = p[i][j] / g;
        }
    }

    i = 0;
    for(j = 0; j < m; j++)
    {
        k = i;
        while(k < n && p[k][j] == 0)
            k++;

        if(k < n)
        {
            if(k != i)
                for(l = j; l <= m; l++)
                {
                        swap(p[i][l], p[k][l]);
                        swap(q[i][l], q[k][l]);
                }

            for(l = j + 1; l <= m; l++)
            {
                p[i][l] = p[i][l] * q[i][j];
                q[i][l] = q[i][l] * p[i][j];

                g = gcd(p[i][l], q[i][l]);
                if(g > 1)
                {
                    p[i][l] = p[i][l] / g;
                    q[i][l] = q[i][l] / g;
                }

                if(q[i][l] < 0)
                {
                    p[i][l] = -p[i][l];
                    q[i][l] = -q[i][l];
                }
            }
            p[i][j] = 1;
            q[i][j] = 1;


            for(k = 0; k < n; k++)
            {
                if(k == i || p[k][j] == 0)
                    continue;

                for(l = j + 1; l <= m; l++)
                {
                    curp = p[i][l] * p[k][j];
                    curq = q[i][l] * q[k][j];

                    g = gcd(curp, curq);
                    if(g > 1)
                    {
                        curp = curp / g;
                        curq = curq / g;
                    }


                    p[k][l] = p[k][l] * curq - q[k][l] * curp;
                    q[k][l] = q[k][l] * curq;

                    g = gcd(p[k][l], q[k][l]);
                    if(g > 1)
                    {
                        p[k][l] = p[k][l] / g;
                        q[k][l] = q[k][l] / g;
                    }

                    if(q[k][l] < 0)
                    {
                        p[k][l] = -p[k][l];
                        q[k][l] = -q[k][l];
                    }
                }
                p[k][j] = 0;
                q[k][j] = 1;

                l = 0;
                while(l < m && p[k][l] == 0)
                    l++;

                if(l == m)
                {
                    if(p[k][m] != 0)
                    {
                        printf("No solution\n");
                        return 0;
                    }

                    for(l = j; l <= m; l++)
                        p[k][l] = p[n - 1][l];
                    n--;
                    k--;
                }
            }

            i++;
        }

        if(i >= n)
            break;
    }

    if(i == m)
    {
        for(k = 0; k < n - 1; k++)
        {
            print(k, m);
            printf(" ");
        }
        print(k, m);
        printf("\n");
    }
    else
    {
        for(k = 0; k < n; k++)
        {
            for(l = 0; l < m; l++)
            {
                print(k, l);
                printf(" ");
            }
            print(k, l);
            printf("\n");
        }
    }

    return 0;
}















