#include <iostream>
#include <fstream>
#include <vector>
#include <cmath>
#include <algorithm>


using namespace std;


ifstream fin("linear.in");
ofstream fout("linear.out");

const int maxn=8000;
int n, m;
vector< vector<int> > f, p;
vector<int> pasted, ansp, ansf;
bool oneAns=true;

void show(){
    for(int i=0; i<n; i++){
        for(int z=0; z<=m; z++){
            cout<<f[i][z]<<'/'<<p[i][z]<<' ';
        }
        cout<<endl;
    }
    cout<<endl;
}

int nsd(int a, int b){
    a=abs(a);
    b=abs(b);
    while(a>0 && b>0){
        if(a>b) a-=b;
         else b-=a;
    }
    return a+b;
}


void factor(int f1, int p1, int a, int b){
    if (f1<0 && p1<0){
        f1=abs(f1);
        p1=abs(p1);
    }
    if(f1>=0 && p1<0){
        p1=abs(p1);
        f1*=-1;
    }
    int i=nsd(f1, p1);
    f[a][b]=f1/i;
    p[a][b]=p1/i;
}
void diff(int f1, int p1, int f2, int p2, int a, int b){
    factor(f1*p2-f2*p1, p1*p2, a, b);
}

void numOut(int a, int b){
    fout<<' '<<a;
    if(b!=1){
        fout<<'/'<<b;
    }
}

bool numInVec(int a, vector<int> b){
    for(int i=0; i<b.size(); i++){
        if (b[i]==a) return true;
    }
    return false;
}

int main(){

    int i, z;
    fin>>n>>m;
    f=vector< vector<int> >(n, vector<int>(m+1));
    p=vector< vector<int> >(n, vector<int>(m+1, 1));
    for(i=0; i<n; i++){
        for(z=0; z<=m; z++){
            fin>>f[i][z];
        }
    }

    //GOING DOWN
    for(i=0; i<n; i++){
        //FINDING LINE NOT STARTING WITH 0
        for(z=i; z<n; z++){
            if(f[z][i]!=0){
                swap(f[i], f[z]);
                swap(p[i], p[z]);
                break;
            }
        }

        //IF EVERYWHERE IS 0
        if(f[i][i]==0){
            f.insert(f.begin()+i, vector<int>(m+1, 0));
            p.insert(p.begin()+i, vector<int>(m+1, 1));
            pasted.push_back(i);
            n++;
            continue;
        }

        //SET TO 1
        for(z=m; z>=i; z--){
            factor(f[i][z]*p[i][i], p[i][z]*f[i][i], i, z);
        }


        //MAKE 0 UNDER
        for(z=i+1; z<n; z++){
            if(f[z][i]==0) continue;
            for(int t=m; t>=i; t--){
                factor(f[z][t]*p[z][i], p[z][t]*f[z][i], z, t);
                diff(f[z][t], p[z][t], f[i][t], p[i][t], z, t);
            }
        }

    }


bool noSol=false;
if(m<n && f[m][m]!=0) noSol=true;

    //GOING UP
    for(i=n-1; i>=0 && !noSol; i--){
        ansf.push_back(f[i][m]);
        ansp.push_back(p[i][m]);

        //MAKE 0 ABOVE 1
        for(z=0; z<i; z++){
            //FACTOR TO MULTIPLY
            if(f[z][i]==0) continue;
            int ff=p[z][i];
            int fp=f[z][i];
            //MAIN PART
            for(int t=m; t>=max(0, i-1); t--){
                if(f[i][t]!=0 && t!=i && t!=m) oneAns=false;
                diff(f[z][t], p[z][t], f[z][i]*f[i][t], p[z][i]*p[i][t], z, t);
            }
        }
    }

    for(i=1; i<m; i++){
        if(f[0][i]!=0) oneAns=false;
    }


    //FILE OUT ANSWER
    if(noSol){
        fout<<"No solution"<<endl;
    } else if (oneAns){
        int last=ansf.size()-1;
        for(i=last; i>=0; i--){
            if(!numInVec(i, pasted)){
                numOut(ansf[i], ansp[i]);
            }
        }
        fout<<endl;
    } else {
        for(i=0; i<n; i++){
            if(numInVec(i, pasted)) continue;
            for(z=0; z<=m; z++){
                numOut(f[i][z], p[i][z]);
            }
            fout<<endl;
        }
    }

    fin.close();
    fout.close();
    return 0;
}
