#include <cstdio>
#include <vector>
#include <utility>
#include <algorithm>
#include <cstdlib>

using namespace std;

vector<vector<pair<int,int> > > A;
int n,m;

int gcd(int q, int w) { return ((q == 0)?w:gcd(w%q, q)); }

pair<int, int> Norm(pair<int, int> q){
    int g = gcd(abs(q.first), abs(q.second));
    q.first /= g;
    q.second /= g;
    if (q.second < 0) {q.first *= -1; q. second *= -1;}
    return q;
}

pair<int, int> Div(pair<int, int> q, pair<int, int> w){
    return Norm(make_pair(q.first*w.second, q.second*w.first));
}

pair<int, int> Mult(pair<int, int> q, pair<int, int> w){
    return Norm(make_pair(q.first*w.first, q.second*w.second));
}

pair<int, int> Add(pair<int, int> q, pair<int, int> w){
    return Norm(make_pair(q.first*w.second + q.second*w.first, q.second*w.second));
}

void PrintP(pair<int, int> q){
    printf("%d", q.first);
    if (q.second != 1) printf("/%d", q.second);
    return;
}

void PrintA(int ur){
    for (int k = 0; k < ur; k++){
        for (int i = 0; i < m+1; i++) {printf(" "); PrintP(A[k][i]);}
        printf("\n");
    }
    return;
}

void Rec(int ur, int per){

    if (ur == n || per == m){
        for (int i = ur; i < n; i++) if (A[i][m].first != 0){
            printf("No solution\n");
            return;
        }

        if (n>= m && A[m-1][m-1].first != 0){
            for (int i=0; i<m; i++) {printf(" "); PrintP(A[i][m]);}
            printf("\n");
            return;
        }
        PrintA(ur);
        return;
    }

    for (int k = ur; k < n; k++) if (A[k][per].first != 0){
        swap(A[ur], A[k]);
        break;
    }

    if (A[ur][per].first == 0) {Rec(ur, per + 1); return; }

    for (int k = per+1; k < m+1; k++) A[ur][k] = Div(A[ur][k], A[ur][per]);
    A[ur][per] = make_pair(1,1);

    for (int k = 0; k < n; k++) if (A[k][per].first != 0 ) if (k != ur){
        pair<int, int> coef = Mult(A[k][per], make_pair(-1,1));
        for (int i = per; i < m+1; i++) A[k][i] = Add(A[k][i], Mult(coef, A[ur][i]));
    }

    Rec(ur+1, per+1);
}



int main(){
    freopen("linear.in", "r", stdin);
    freopen("linear.out", "w", stdout);
    scanf("%d%d", &n, &m);
    A.resize(n);
    for (int j = 0; j < n; j++){
        A[j].assign(m+1, make_pair(0,1));
        for (int k = 0; k < m+1; k++) scanf("%d", &A[j][k]);
    }
    Rec(0,0);

    fclose(stdin);
    fclose(stdout);
}
