/* GCC */

#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cmath>
#include <stdint.h>
#include <string>
#include <ctype.h>
#include <sstream>
#include <map>
#include <string.h>
using namespace std;

typedef int64_t ll;

struct Element
{
    string id;
};

bool operator==(Element l, Element r) {return l.id == r.id;}
bool operator<(Element l, Element r) {return l.id < r.id;}

istream& operator>>(istream& i, Element& e)
{
    char ch = i.get();
    if (!isupper(ch)) {
        i.putback(ch);
        return i;
    }
    do  {
        e.id.push_back(ch);
        ch = i.get();
    } while (islower(ch));

    i.putback(ch);
    return i;
}

char top(istream& i)
{
    char ch = i.get();
    i.putback(ch);

    return ch;
}

map<Element, int> elems;
map<int, Element> revers;

istringstream koffs, form;
int COUNT = 0;

string k, f;

int get_id(Element e)
{
    if (elems.find(e) != elems.end()) {
        return elems[e];
    } else {
        elems.insert(make_pair(e, COUNT));
        revers.insert(make_pair(COUNT, e));
        ++COUNT;
        return COUNT-1;
    }
}

struct Substance
{
    map<int, int> cont;

    void add(Element e, int k) {
        int id = get_id(e);
        if (cont.find(id) != cont.end()) {
            cont[id] += k;
        } else
            cont.insert(make_pair(id, k));
    }

    void show()
    {
        for (map<int, int>::iterator i = cont.begin(); i != cont.end(); ++i) {
            cerr << revers[i->first].id << " " << i->second << "\n";
        }
    }

    int get(int id)
    {
        if (cont.find(id) != cont.end()) {
            return cont[id];
        } else
            return -1;
    }
};

istream& operator>>(istream& i, Substance& s)
{
    char ch = top(i);

    while (ch != '+' && ch != '=' && ch != string::npos) {
         if (ch == '(') {
            i.get();
            vector<Element> temp;
            int k = 1;
            //koffs >> k;
            while (ch != ')' && !i.eof()) {
                Element t;
                i >> t;
                temp.push_back(t);
                ch = top(i);
            }
            i.get();
            ch = top(i);
            /*if (ch == string::npos)
                return i;*/

            if (ch == ' ')
                koffs >> k;

            for (int i = 0; i < temp.size(); ++i)
                s.add(temp[i], k);

            continue;
        }
        if (isupper(ch)) {
            Element t;
            i >> t;
            ch = top(i);
            /*if (ch == string::npos)
                return i;*/

            int k = 1;
            if (ch == ' ')
                koffs >> k;
            s.add(t, k);
            continue;
        }
        i.get();
        ch = top(i);
    }
    return i;
}

int L,  N;
vector<Substance> all;

vector<vector<int> > equatations;

void make_eqs()
{
    for (int el = 0; el < COUNT; ++el) {
        equatations.push_back(vector<int>(all.size()));

        for (int i = 0; i < all.size(); ++i) {
            Substance sub = all[i];
            int k = sub.get(el);
            if (k != -1) {
                if (i >= L)
                    k *= -1;
                equatations[el][i] = k;
            }
        }
    }
}

int a[10] = {};
bool FINISHED = false;

bool check()
{
    for (int i = 0; i < equatations.size(); ++i) {
        int s = 0;
        for (int j = 0; j < equatations[i].size(); ++j) {
            s += a[j]*equatations[i][j];
        }
        if (s != 0)
            return false;
    }

    return true;
}

void truncate(string& s)
{
    int i = s.size()-1;
    while (s[i] == ' ') {
        s.erase(s.end()-1);
        --i;
    }
}

int limit;

void backtrack(int j)
{
    if (FINISHED)
        return;
    if (j == all.size()) {
        //int c[4] = {1, 2, 1, 2};
        //memcpy(a, c, 4*4);
        if (check()) {
            int ind = 0;
            for (int i = 0; i < all.size(); ++i) {
                if (a[i] != 1) {
                    f.insert(f.begin()+ind, (char)(a[i]+'0'));
                    k.insert(k.begin()+ind, ' ');
                }
                while (ind < f.size() && f[ind] != '=' && f[ind] != '+') {
                    ++ind;
                }
                ++ind;
            }
            ofstream cout("chemie.out");
            cout << f << "\n";
            truncate(k);
            cout << k << "\n";
            FINISHED = true;
        }
        return;
    }
    for (int i = 1; i <= limit; ++i) {
        a[j] = i;
        backtrack(j+1);
    }
}

int main()
{
    ifstream cin("chemie.in");

    char ch = cin.get();
    cin.putback(ch);



    getline(cin, f);
    form.str(f);
    form.clear();

    getline(cin, k);
    koffs.str(k);
    koffs.clear();

    for (int i = k.size(); i < f.size(); ++i) {
        k.push_back(' ');
    }

    vector<Substance> left;
    while(top(form) != '=') {
        Substance s;
        form >> s;
        left.push_back(s);
        char ch = top(form);
        if (ch == '+') {
            form.get();
            ch = top(form);
        }
    }
    form.get();
    vector<Substance> right;

    while(top(form) != string::npos) {
        Substance s;
        form >> s;
        right.push_back(s);
        char ch = top(form);
        if (ch == '+') {
            form.get();
            ch = top(form);
        }
    }

    all = left;

    for (int i = 0; i < right.size(); ++i) {
        all.push_back(right[i]);
    }
   /* for (int i = 0; i < all.size(); ++i) {
        cerr << "---------------\n";
        all[i].show();
    }*/
    L = left.size();
    N = all.size();

    make_eqs();

    /*for (int i = 0; i < equatations.size(); ++i) {
        for (int j = 0; j < equatations[i].size(); ++j)
            cerr << equatations[i][j] << " ";
        cerr << endl;
    }*/
    limit = 6;
    backtrack(0);

    return 0;
}
