/* GCC */
#include <iostream>
#include <fstream>
#include <cmath>
#include <vector>

using namespace std;

typedef long long ll;

const ll MAX=8e3+1;

ll gcd(ll a, ll b)
{
    while(b)
    {
        a%=b;
        swap(a, b);
    }
    return a;
}

ll lcm(ll a, ll b)
{
    return a*b/gcd(a, b);
}

struct fraction
{
    ll up, down;
    fraction(): up(0), down(1) {}
    fraction(ll a, ll b)
    {
        up=a, down=b;
        if(down<0)
            up=-up, down=-down;
        ll tmp=gcd(abs(up), abs(down));
        up/=tmp, down/=tmp;
    }
    operator bool()
    {
        return up!=0;
    }
    bool operator != (fraction f)
    {
        return up!=f.up||down!=f.down;
    }
    fraction operator + (fraction f)
    {
        return fraction(up*f.down+f.up*down, down*f.down);
    }
    fraction operator - (fraction f)
    {
        return fraction(up*f.down-f.up*down, down*f.down);
    }
    fraction operator * (fraction f)
    {
        return fraction(up*f.up, down*f.down);
    }
    fraction operator / (fraction f)
    {
        return fraction(up*f.down, down*f.up);
    }
    friend istream&  operator >> (istream& in, fraction& f)
    {
        ll tmp;
        in >> tmp;
        f=fraction(tmp, 1);
        return in;
    }
    friend ostream&  operator << (ostream& out, fraction& f)
    {
        out << f.up;
        if(f.down!=1)
            out << '/' << f.down;
        return out;
    }
};

ll n, m, zero;
bool no;
fraction arr[MAX], ans[MAX], bns[MAX];

template <class T>
T& get(T* a, ll x, ll y)
{
    return arr[x*(m+1)+y];
}

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("linear.in");
    ofstream cout("linear.out");
    cin >> n >> m;
    for(ll i=0; i<n; ++i)
        for(ll j=0; j<m+1; ++j)
            cin >> get(arr, i, j);
    for(ll i=0; i<n-zero; ++i)
    {
        ll cnt=0;
        for(ll j=0; j<m+1; ++j)
            if(get(arr, i, j))
                ++cnt;
        if(cnt==1)
            no=true;
        if(cnt==0)
        {
            if(i!=n-zero-1)
            {
                for(ll k=0; k<m+1; ++k)
                    swap(get(arr, i, k), get(arr, n-zero-1, k));
                --i;
            }
            ++zero;
        }
    }
    for(ll i=0; i<n-zero; ++i)
    {
        for(ll j=i+1; j<n-zero; ++j)
        {
            bool flag=true;
            vector  <fraction> vec;
            for(ll k=0; k<m+1; ++k)
            {
                if(get(arr, i, k)&&!get(arr, j, k))
                    flag=false;
                if(!get(arr, i, k)&&get(arr, j, k))
                    flag=false;
                if(get(arr, i, k)&&get(arr, j, k))
                    vec.push_back(get(arr, i, k)/get(arr, j, k));
            }
            for(ll i=1; i<vec.size(); ++i)
                if(vec[i]!=vec[i-1])
                    flag=false;
            if(flag)
            {
                if(j!=n-zero-1)
                {
                    for(ll k=0; k<m+1; ++k)
                        swap(get(arr, j, k), get(arr, n-zero-1, k));
                    --j;
                }
                ++zero;
            }
        }
    }
    for(ll step=0; step<m-1&&!no&&(n-zero>=m); ++step)
    {
            ll tmp=0;
            for(ll i=step; i<n-zero; ++i)
                if(get(arr, i, step))
                    tmp=i;
            for(ll i=0; i<m+1; ++i)
                swap(get(arr, step, i), get(arr, tmp, i));
            for(ll i=step+1; i<n-zero; ++i)
            {
                fraction now=get(arr, i, step)/get(arr, step, step);
                ll cnt=0;
                for(ll j=0; j<m+1; ++j)
                {
                    get(arr, i, j)=get(arr, i, j)-get(arr, step, j)*now;
                    if(get(arr, i, j))
                        ++cnt;
                }
                if(cnt==1)
                    no=true;
            }
    }
    if(!no&&(n-zero>=m))
    {
        for(ll step=n-1-zero; step>=0; --step)
        {
            fraction sum;
            for(ll i=0; i<m; ++i)
                if(i!=step)
                    sum=sum+get(arr, step, i)*ans[i];
            ans[step]=(get(arr, step, m)-sum)/get(arr, step, step);
        }
        for(ll i=0; i<m; ++i)
            cout << ' ' << ans[i];
    }
    else if(no)
        cout << "No solution\n";
    else
    {
        for(ll i=0; i<n-zero; ++i)
        {
            for(ll j=0; j<m+1; ++j)
            {
                fraction tmp=get(arr, i, j)/get(arr, i, 0);
                cout << ' ' << tmp;
            }
            cout << endl;
        }
    }
    return 0;
}
