""" Python 3 """

from fractions import Fraction as Fr

fin = open('linear.in')
fout = open('linear.out', 'w')

def output(b):
    fout.write(' ' + str(b.numerator))
    if b.denominator != 1:
        fout.write('/' + str(b.denominator))

n, m = [int(i) for i in fin.readline().split()]
a = [[Fr(i) for i in fin.readline().split()] for j in range(n)]
unkn = []
    
for k in range(m):         # transforming matrix to triangular form
    for i in range(k+1, n):
        mul = a[i][k]/a[k][k]
        for j in range(k, m+1):
            a[i][j] -= mul*a[k][j]

i = 0
flag = False
while i < len(a):
    f = False               # checking if the matrix is solveable
    if not any(a[i][:m]):
        if a[i][m] != 0:
            fout.write('No solution\n')
            flag = True
            break
        else:
            f = True
            del a[i]
    if not f: i += 1
    
if not flag:            # checking if the matrix has infinite solutions
    if len(a) < m:
        for i in range(len(a)):
            for j in range(m+1):
                b = a[i][j]/a[i][i]
                output(b)
            fout.write('\n')
    else:
        for i in range(m-1, -1, -1):   # searching for the solution
            s = 0
            for j in range(i+1, m):
                s += a[i][j]*unkn[m-j-1]
            unkn.append((a[i][m]-s)/a[i][i])
        for i in reversed(unkn):
            output(i)
        fout.write('\n')

fin.close()
fout.close()
