/* GCC */
#include <fstream>
#include <string>
#include <iomanip>
#include <cmath>
#include <vector>
#include <cctype>
#include <algorithm>
#include <map>

using namespace std;

int table[1000][10] = {}, m, n, ans[10], cur[1000] = {}, beg[10], solved = false;

void solve(int c)
{
	if (c == m)
	{
		bool good = true;
		for (int i = 0; i < n; ++i)
			if (cur[i] != 0)
			{
				good = false;
				break;
			}
		if (good)
			solved = true;
		return;
	}
	for (int var = 1; var <= 30; ++var)
	{
		ans[c] = var;
		for (int i = 0; i < n; ++i)
			cur[i] += table[i][c] * var;
		solve(c + 1);
		if (solved)
			return;
		for (int i = 0; i < n; ++i)
			cur[i] -= table[i][c] * var;
	}
}

int main(void)
{
	ios_base::sync_with_stdio(false);
	ifstream in("chemie.in");
	map<string, int> atom;
	char ch;
	int curIdx = 0, curAi = 0, cAcnt = 0;
	bool eq = false, g = false, just = true;
	string str, coef, curAtom;
	getline(in, str);
	getline(in, coef);
	if (coef.size() > str.size())
		str.append(coef.size() - str.size(), ' ');
	else if (coef.size() < str.size())
		coef.append(str.size() - coef.size(), ' ');
	vector<pair<int, int> > gr;
	for (int i = 0; i < str.size() + 1; ++i)
	{
		if (i == str.size())
			ch = '+';
		else
			ch = str[i];
		if (ch == '=')
		{
			if (curAtom.size())
			{
				if (atom.find(curAtom) == atom.end())
					atom[curAtom] = curAi++;
				if (cAcnt == 0)
					cAcnt = 1;
				if (g)
					gr.push_back(make_pair(atom[curAtom], cAcnt));
				else
					table[atom[curAtom]][curIdx] += cAcnt;
			}
			eq = true;
			++curIdx, just = true;
			curAtom.clear();
			cAcnt = 0;
			continue;
		}
		if (ch == '+')
		{
			if (curAtom.size())
			{
				if (atom.find(curAtom) == atom.end())
					atom[curAtom] = curAi++;
				if (cAcnt == 0)
					cAcnt = 1;
				if (g)
					gr.push_back(make_pair(atom[curAtom], cAcnt));
				else
					table[atom[curAtom]][curIdx] += (eq ? -cAcnt : cAcnt);
			}
			++curIdx, just = true;
			curAtom.clear();
			cAcnt = 0;
			continue;
		}
		if (ch == '(')
		{
			if (curAtom.size())
			{
				if (atom.find(curAtom) == atom.end())
					atom[curAtom] = curAi++;
				if (cAcnt == 0)
					cAcnt = 1;
				table[atom[curAtom]][curIdx] += (eq ? -cAcnt : cAcnt);
				curAtom.clear();
				cAcnt = 0;
			}
			g = true;
			continue;
		}
		if (ch == ')')
		{
			if (atom.find(curAtom) == atom.end())
				atom[curAtom] = curAi++;
			if (cAcnt == 0)
				cAcnt = 1;
			gr.push_back(make_pair(atom[curAtom], cAcnt));
			curAtom.clear();
			cAcnt = 0;
			if (i != str.size() - 1 && str[i + 1] == ' ')
			{
				cAcnt = coef[++i] - '0';
				for (int j = 0; j < gr.size(); ++j)
					table[gr[j].first][curIdx] += (eq ? -1 : 1)*(gr[j].second * cAcnt);
			}
			gr.clear();
			g = false;
			continue;
		}
		if (ch == ' ')
		{
			cAcnt = coef[i] - '0';
			continue;
		}
		if (isupper(ch))
		{
			if (just)
				beg[curIdx] = i;
			if (!just && curAtom.size())
			{
				if (atom.find(curAtom) == atom.end())
					atom[curAtom] = curAi++;
				if (cAcnt == 0)
					cAcnt = 1;
				if (g)
					gr.push_back(make_pair(atom[curAtom], cAcnt));
				else
					table[atom[curAtom]][curIdx] += (eq ? -cAcnt : cAcnt);
			}
			curAtom.clear();
			cAcnt = 0;
			curAtom.push_back(ch);
			just = false;
		}
		else
			curAtom.push_back(ch);
	}
	in.close();
	// table[curAi][curIdx]
	n = curAi, m = curIdx;
	solve(0);
	int ad(0);
	for (int i = 0; i < m; ++i)
	{
		string addd;
		if (ans[i] == 1)
			continue;
		if (ans[i] < 10)
			addd.push_back('0' + ans[i]);
		else
		{
			addd.push_back('0' + ans[i] / 10);
			addd.push_back('0' + (ans[i] % 10));
		}
		str.insert(beg[i] + ad, addd.c_str());
		coef.insert(beg[i] + ad, addd.size(), ' ');
		ad += addd.size();
	}
	while (str.size() && str[str.size() - 1] == ' ')
		str.erase(str.size() - 1, 1);
	while (coef.size() && coef[coef.size() - 1] == ' ')
		coef.erase(coef.size() - 1, 1);
	ofstream out("chemie.out");
	out << str << '\n' << coef << '\n';
	out.close();
	return 0;
}

